
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java学习笔记21 / 憋错料</title>

    <meta name="description" content="Java学习笔记21 Objects是Java 7新增的一个工具类,它提供了一些工具方法来操作对象,这些工具方法大多是&quot;空指针&quot;安全的. Objects实现的方法如下: requireNonNull(T)与requireNonNull(T,String)在源码中定义如下: public static &lt;T&gt; T requireNonNull(T obj) { if (obj == null) throw new NullPointerException(); return obj; } ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Java学习笔记21</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>Objects是Java 7新增的一个工具类，它提供了一些工具方法来操作对象，这些工具方法大多是“空指针”安全的。</p>
<p>Objects实现的方法如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTAyMjUyMTU1MjkyNjA/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YUdGcFgzRnBibWRmZUhWZmEyOXVadz09L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p>requireNonNull(T)与requireNonNull(T,String)在源码中定义如下：</p>
<pre>public static &lt;T&gt; T requireNonNull(T obj) {
        if (obj == null)
            throw new NullPointerException();
        return obj;
    }</pre>
<pre>  public static &lt;T&gt; T requireNonNull(T obj, String message) {
        if (obj == null)
            throw new NullPointerException(message);
        return obj;
    }</pre>
<p>在使用上面requireNonNull(T)方法时，当传入的参数不为null时，返回参数本身，反之，抛出一个NullPointerException异</p>
<p>常。而requireNonNull(T,String)方法的作用是，传入的参数不为null时，返回参数本身，否则抛出message的</p>
<p>NullPointerException异常。</p>
<p>接着我们来看看isNull(Object)方法与nonNull(Object)方法在源码中定义如下：</p>
<pre>public static boolean isNull(Object obj) {
        return obj == null;
    }</pre>
<pre> public static boolean nonNull(Object obj) {
        return obj != null;
    }</pre>
<p>从上面的程序中可以看出isNull(Object)方法是判断传入的对象是否为null，为null返回true,否则false。nonNull(Object</p>
<p>obj)方法恰恰相反,判断传入的对象是否为null，为null返回false,否则返回true。</p>
<p>最后我们看下requireNonNull(T,Supplier&lt;String&gt;)方法：</p>
<pre> public static &lt;T&gt; T requireNonNull(T obj, Supplier&lt;String&gt; messageSupplier) {
        if (obj == null)
            throw new NullPointerException(messageSupplier.get());
        return obj;
    }</pre>
<p>在这里传入一个Supplier接口实现类的对象，Supplier接口定义如下：</p>
<pre>public interface Supplier&lt;T&gt; {

    /**
     * Gets a result.
     *
     * @return a result
     */
    T get();
}
</pre>
<p>因此requireNonNull(T,Supplier&lt;String&gt;)方法与前面介绍的两个requireNonNull方法相&#20284;，当传入参数不为null，返回参</p>
<p>数本身，否则引发NullPointerException异常。</p>
<p>看下requireNonNull(T,Supplier&lt;String&gt;)方法如何使用：</p>
<pre>class User {

    public String name;
    public int age;

    public User(String name,int age){
    	this.name=name;
    	this.age=age;
    }

    protected String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Override
    public String toString() {
    	return &quot;name=&quot;+name+&quot;\nage=&quot;+age;
    }

}
public class Main {
	public User user1,user2;

	public static void main(String[] args) {
		new Main().init();
	}

	public void init(){
		User user1 = null;
		User message=Objects.requireNonNull(user1, new Supplier&lt;String&gt;() {

			@Override
			public String get() {
				return &quot;user1这个对象为null&quot;;
			}
		});

	}
}</pre>
<p>输出：</p>
<p>Exception in thread &quot;main&quot; java.lang.NullPointerException: user1这个对象为null</p>
<p>at java.util.Objects.requireNonNull(Objects.java:290)</p>
<p>at code2.Main.init(Main.java:50)</p>
<p>at code2.Main.main(Main.java:45)</p>
<p>很明显以上程序抛出NullPointerException异常，并输出Supplier接口实现的get方法。</p>
<p>转载请注明出处：<a href="http://blog.csdn.net/hai_qing_xu_kong/article/details/43940885" rel="external nofollow noreferrer">http://blog.csdn.net/hai_qing_xu_kong/article/details/43940885</a>&nbsp;&nbsp;&nbsp;情绪控_</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 03:47:38 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/java/" title="java">java</a>, <a href="https://www.biecuoliao.com/tag/isnull/" title="isnull">isnull</a>, <a href="https://www.biecuoliao.com/tag/objects/" title="objects">objects</a>, <a href="https://www.biecuoliao.com/tag/requirenonnull/" title="requirenonnull">requirenonnull</a>, <a href="https://www.biecuoliao.com/tag/nonnull/" title="nonnull">nonnull</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Java学习笔记21的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/j35rdo4.html" rel="bookmark">我的java学习笔记&lpar;21&rpar;关于框架定位</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.AWT和Swing中框架和组件类的继承层次. 2.组件类的很多方法是以获取或设置方法对形式出现的. public String getTitle(); public void setTitle(Stirng title); 3.对于类型为boolean的属性,获取方法由is开头. public boolean isLocationByPlatform(); public void setLocationByPlatform(boolean b); 4.如果没有明确地指出指定框架的大小,所有框			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35aVZ13.html" rel="bookmark">Java学习笔记21（String类补充：正则表达式）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				正如python的re模块,不过Java和Python的正则表达式有一些区别,这里做简单介绍,具体的细节可以参考网上其他的文章: 功能:可以用于检验一个字符串,比如验证用户名,验证密码格式,验证是否是邮箱,等等 示例: &quot;[0-9]{6,12}&quot;匹配规则:6到12位的数字,比如123456789就是true,12345就是false &quot;1[3578][0-9]{9}&quot;匹配规则:1开头,第二位是3578中的一个,后面九个任意数字,比如13345678912就是true			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YYyjW0.html" rel="bookmark">java学习笔记3&mdash;&mdash;java关键字</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				java学习笔记3——java关键字 虽然老师说不用刻意的去记忆,但是我还是在网上找到了非常详细的注解,再次收藏 关键字的类型表: 各个关键字的详细注解和实例,按首字母排序: 1.abstract abstract 关键字可以修改类或方法. abstract 类可以扩展(增加子类),但不能直接实例化. abstract 方法不在声明它的类中实现,但必须在某个子类中重写. -示例- public abstract class MyClass{ } public abstract String my			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmD2kK4.html" rel="bookmark">【Java学习笔记之二十六】深入理解Java匿名内部类</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在[Java学习笔记之二十五]初步认知Java内部类中对匿名内部类做了一个简单的介绍,但是内部类还存在很多其他细节问题,所以就衍生出这篇博客.在这篇博客中你可以了解到匿名内部类的使用.匿名内部类要注意的事项.如何初始化匿名内部类.匿名内部类使用的形参为何要为final. 一.使用匿名内部类内部类 匿名内部类由于没有名字,所以它的创建方式有点儿奇怪.创建格式如下: new 父类构造器(参数列表)|实现接口() { //匿名内部类的类体部分 } 在这里我们看到使用匿名内部类我们必须要继承一个父类或者			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEvWaQ0.html" rel="bookmark">Java学习笔记之继承</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.继承的基础 在Java术语中,被继承的类叫超类(superclass),继承超类的类叫子类(subclass). 举例说明: 1 class Box 2 { 3 public double width; 4 public double height; 5 public double depth; 6 7 //重载构造方法 8 public Box(Box ob) 9 { 10 width = ob.width; 11 height = ob.height; 12 depth = ob.dep			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDrade3.html" rel="bookmark">Java学习笔记之接口</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.接口的概念与定义 首先考虑一个简单的接口的定义: public interface Output { int MAX_LINE = 40; void out(); void getData(String msg); } 定义接口使用关键字interface 修饰符interface前面的public可以省略,如果省略,则采用默认访问控制,即只有在相同包结构的代码才可以访问此接口 接口不可以有构造方法(区别于类中的构造方法) 接口里面的所有成员,包括常量.方法等都是public访问权限,所以在			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JvDdb4.html" rel="bookmark">java学习笔记13--比较器&lpar;Comparable、Comparator&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				java学习笔记13--比较器(Comparable.Comparator) 分类: JAVA 2013-05-20 23:20 3296人阅读 评论(0) 收藏 举报 Comparable接口的作用 之前Arrays类中存在sort()方法,此方法可以直接对对象数组进行排序. Comparable接口 可以直接使用java.util.Arrays类进行数组的排序操作,但对象所在的类必须实现Comparable接口,用于指定排序接口. Comparable接口的定义如下: public  int			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzX7yd3.html" rel="bookmark">java学习笔记 第二篇 核心技术（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第十四章 集合类 集合类用来存放对象的引用.继承关系如下图: 14.1 Collection 接口 是层次结构中的根接口,构成Collection的单位称为元素.Collection接口不能直接使用,但该接口提供了添加元素.删除元素.管理数据的方法. Collection接口常用方法: 14.2 List 集合 包括List接口以及List集合的所有实现类.List集合中的元素允许重复,各元素循序就是对象插入的顺序 1.List接口,两个重要方法: get(int index): 获取指定索引位			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVWrNz0.html" rel="bookmark">Java学习笔记&lowbar;21&lowbar;Collection接口</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				21.Collection接口: 1&gt;容器类的添加.删除: · add(Object o) :将对象添加到集合. · Remove(Object o) :删除集合中与o相匹配的对象. 2&gt;容器中类的查询: · Size(): 返回集合中元素的个数. · isEmpty(): 判断集合中是否包含元素. · contains(Object o): 判断集合中是否包含指定元素. · iterator(): 返回集合的一个迭代器,用来访问该集合的元素. · contains(Collection c)			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Z0KqLm4.html" rel="bookmark" class="title">数据结构 笔记2 线性表</a>
					<div>
						线性表是最简单,最常用的一种数据结构,它是由n个数据元素(结点)组成的有限序列. 线性表的基本运算 1.置空表 InitList(L) ,构造一个空的线性表L 2.求表长 ListLength(L)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/v0kLmE3.html" rel="bookmark" class="title">模块化编程</a>
					<div>
						#用&quot;from ... import *&quot;来执行代码模块中的函数,就不需要提到模块名,而且可以使用模块中定义的变量 #如果你需要使用完全限定名(FQN)来用模块名限定函数名(这也是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0awkzR4.html" rel="bookmark" class="title">图片预加载和懒加载</a>
					<div>
						1.什么是预加载? 提前加载图片,当用户需要查看时可直接从本地缓存中渲染. 2:什么是懒加载? 延迟加载图片,当用户需要的时候再去加载图片 当我们访问一些类似电商网站,遇到图片很多情况下,需要浏览器去 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35bA6R4.html" rel="bookmark" class="title">ORACLE查询表最近更改数据的方法</a>
					<div>
						修改项目时,涉及到了Oracle中许多表的修改(包括:增加.删除字段,修改注释等).由于开始没有进行记录,造成在上测试机时,忘记了具体修改过哪些表了.后来在网上查找了一些资料,例如: 1.select ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLDrKAM.html" rel="bookmark" class="title">git  教程（10）--添加远程库</a>
					<div>
						现在的情景是,你已经在本地创建了一个Git仓库后,又想在GitHub创建一个Git仓库,并且让这两个仓库进行远程同步,这样,GitHub上的仓库既可以作为备份,又可以让其他人通过该仓库来协作,真是一举 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWw7OLM.html" rel="bookmark" class="title">Oracle10g、 Oracle11g完美共存</a>
					<div>
						Oracle10g. Oracle11g完美共存           环境描述 客户服务器上已经安装Oracle9i软件并部署多套数据库,现在客户要求安装Oracle11g软件,并且创建11g数据库, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K2bnyM.html" rel="bookmark" class="title">Individual Project - Word frequency program</a>
					<div>
						1.做这个项目之前,因为之前在OO课中做过一些项目,这钟算法也非常熟悉,因此算上单纯的词法算法,和C#语言中文件操作的学习,预计一天之内应该可以写好.2.实际上做起来时,我发现c#与之前学过的java ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xRV7B4.html" rel="bookmark" class="title">GTY&amp;&num;39&semi;s gay friends 线段树判断区间是否有相同数字</a>
					<div>
						http://acm.hdu.edu.cn/showproblem.php?pid=5172 判断一个区间是否为全排列是: 1.区间总和 = (1 + R - L + 1) * (R - L + 1) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmAQenM.html" rel="bookmark" class="title">CSS从大图中抠取小图完整教程&lpar;background-position应用&rpar;</a>
					<div>
						转:http://www.cnblogs.com/iyangyuan/archive/2013/06/01/3111704.html 相信很多喜欢研究网页界面的童鞋都遇到过一个奇妙的现象:网页中很多图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eyR6a0.html" rel="bookmark" class="title">js 求前n项的 fibnaci 数列和</a>
					<div>
						1 function f(n) { 2 var num1 = 1, 3 num2 = 1; 4 if (n == 1) 5 document.write(num1);//n=1,输出1 6 else  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MElkXy4.html" rel="bookmark" class="title">C&plus;&plus;学习笔记06</a>
					<div>
						面向对象的扩展功能 备注:编译器在编译一个类时,会先扫描类定义(不含函数体),之后才扫描类实现(各个成员函数的函数体,静态成员变量的初始化),所以在类的成员函数里可以访问在后面才出现的成员. cons ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ODrqP4.html" rel="bookmark" class="title">CString转换成int CString类相应函数</a>
					<div>
						CString 型转化成 int 型 把 CString 类型的数据转化成整数类型最简单的方法就是使用标准的字符串到整数转换例程. 虽然通常你怀疑使用_atoi()函数是一个好的选择,它也很少会是一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoaORw3.html" rel="bookmark" class="title">&lbrack;办公应用&rsqb;如何将excel合并单元格分拆后每个单元格上仍保留数据？</a>
					<div>
						合并单元格虽然美观,但是无法进行排序.筛选等操作. 只有合并单元格拆分后才可以按常规进行统计.但是普通拆分后,excel仅保留合并单元格数据到区域左上角的单元格. 解决方案:选定多个合并单元格,应用本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6zNlGM.html" rel="bookmark" class="title">背水一战 Windows 10 &lpar;32&rpar; - 控件（选择类）&colon; Selector&comma; ComboBox</a>
					<div>
						原文:背水一战 Windows 10 (32) - 控件(选择类): Selector, ComboBox [源码下载] 作者:webabcd 介绍背水一战 Windows 10 之 控件(选择类)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kN1JbM.html" rel="bookmark" class="title">Django ~module index</a>
					<div>
						https://docs.djangoproject.com/en/1.9/py-modindex/ django.conf.urls django.contrib.admin django.db.m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGDkLG0.html" rel="bookmark" class="title">架构师养成记--线程基础</a>
					<div>
						为什么要拿线程开头呢?因为线程太重要了,先不说工作中有多重要,单是和money直接挂钩的开发工程师面试就必问题,要是面试没问相关问题的话,要么是应聘者太菜面试官懒得问了,要么是公司太菜,根本不关心多线 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZQxWZ0.html" rel="bookmark" class="title">使用hadoop mapreduce分析mongodb数据：（2）</a>
					<div>
						在上一篇使用hadoop mapreduce分析mongodb数据:(1)中,介绍了如何使用Hadoop MapReduce连接MongoDB数据库以及如何处理数据库,本文结合一个案例来进一步说明Ha ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AaYqD4.html" rel="bookmark" class="title">dipole antenna simulation by HFSS</a>
					<div>
						工作频点为1GHz,新建工程,添加新设计,编辑添加下面的变量 建立天线模型,即两个金属圆柱.编辑完一个振子后,另一半可以用镜像命令产生参数如下设置 ,材料为PEC 两个圆柱间建立一个矩形片,连接两个圆 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pkZL83.html" rel="bookmark" class="title">WEB前端开发中的图片压缩</a>
					<div>
						web前端开发中,图片的重要性不言而喻,而由于一些图片的大小加上现在国内的网速不给力等种种原因,我们非常有必要对网站使用的图片进行压缩,压缩图片必然会带来图片质量的损失,我们要尽可能的在质量降低很小的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEjxmg0.html" rel="bookmark" class="title">微信支付开发流程&lpar;1&sol;2&rpar;</a>
					<div>
						授人以鱼不如授人以渔 微信支付开发流程 下面以PHP语言为例,对微信支付的开发流程进行一下说明. 1.获取订单信息 2.根据订单信息和支付相关的账号生成sign,并且生成支付参数 3.将支付参数信息P ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.037 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
